"""Bindings generated for interface task by rpclib"""

from __future__ import print_function, division

import argparse
import json
import logging
import sys
import traceback

get_str = str
if sys.version_info[0] > 2:
    long = int
    unicode = str
    str = bytes

from xapi import *


class Task_server_dispatcher(object):
    """
    The task interface is for querying the status of asynchronous
    tasks. All long-running operations are associated with tasks,
    including copying and mirroring of data.
    """

    def __init__(self, impl):
        """impl is a proxy object whose methods contain the implementation"""
        self._impl = impl
        self._dispatcher_dict = {
            "Task.stat": self.stat,
            "Task.cancel": self.cancel,
            "Task.destroy": self.destroy,
            "Task.ls": self.ls
        }

    def stat(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "id" not in args:
            raise UnmarshalException('argument missing', 'id', '')
        id = args["id"]
        if not isinstance(id, (str, unicode)):
            raise TypeError("string", repr(id))
        results = self._impl.stat(dbg, id)
        if not isinstance(results['id'], (str, unicode)):
            raise TypeError("string", repr(results['id']))
        if not isinstance(results['debug_info'], (str, unicode)):
            raise TypeError("string", repr(results['debug_info']))
        if not isinstance(results['ctime'], float):
            raise TypeError("float", repr(results['ctime']))
        if results['state'][0] not in ["Pending", "Completed", "Failed"]:
            raise TypeError("| Pending (float) (** The task is in progress, with progress info from 0..1. *) | Completed ({ duration: float; result: | UnitResult (unit) (**  *) | Volume ({ key: string; uuid: string option; name: string; description: string; read_write: bool; sharable: bool; virtual_size: int64; physical_utilisation: int64; uri: string list; keys: (string * string) list; volume_type: | Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *) option; cbt_enabled: bool option; }) (**  *) option; }) (**  *) | Failed (string) (**  *)", repr(results['state']))
        if results['state'][0] == 'Pending':
            if not isinstance(results['state'][1], float):
                raise TypeError("float", repr(results['state'][1]))
        elif results['state'][0] == 'Completed':
            if not isinstance(results['state'][1]['duration'], float):
                raise TypeError("float", repr(results['state'][1]['duration']))
            if 'result' in results['state'][1]:
                if results['state'][1]['result'][0] not in ["UnitResult", "Volume"]:
                    raise TypeError("| UnitResult (unit) (**  *) | Volume ({ key: string; uuid: string option; name: string; description: string; read_write: bool; sharable: bool; virtual_size: int64; physical_utilisation: int64; uri: string list; keys: (string * string) list; volume_type: | Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *) option; cbt_enabled: bool option; }) (**  *)", repr(results['state'][1]['result']))
                if results['state'][1]['result'][0] == 'Volume':
                    if not isinstance(results['state'][1]['result'][1]['key'], (str, unicode)):
                        raise TypeError("string", repr(results['state'][1]['result'][1]['key']))
                    if 'uuid' in results['state'][1]['result'][1]:
                        if not isinstance(results['state'][1]['result'][1]['uuid'], (str, unicode)):
                            raise TypeError("string", repr(results['state'][1]['result'][1]['uuid']))
                    if not isinstance(results['state'][1]['result'][1]['name'], (str, unicode)):
                        raise TypeError("string", repr(results['state'][1]['result'][1]['name']))
                    if not isinstance(results['state'][1]['result'][1]['description'], (str, unicode)):
                        raise TypeError("string", repr(results['state'][1]['result'][1]['description']))
                    if not isinstance(results['state'][1]['result'][1]['read_write'], bool):
                        raise TypeError("bool", repr(results['state'][1]['result'][1]['read_write']))
                    if not isinstance(results['state'][1]['result'][1]['sharable'], bool):
                        raise TypeError("bool", repr(results['state'][1]['result'][1]['sharable']))
                    if not isinstance(results['state'][1]['result'][1]['virtual_size'], (int, long)):
                        raise TypeError("int64", repr(results['state'][1]['result'][1]['virtual_size']))
                    if not isinstance(results['state'][1]['result'][1]['physical_utilisation'], (int, long)):
                        raise TypeError("int64", repr(results['state'][1]['result'][1]['physical_utilisation']))
                    if not isinstance(results['state'][1]['result'][1]['uri'], list):
                        raise TypeError("string list", repr(results['state'][1]['result'][1]['uri']))
                    for tmp_54 in results['state'][1]['result'][1]['uri']:
                        if not isinstance(tmp_54, (str, unicode)):
                            raise TypeError("string", repr(tmp_54))
                    if not isinstance(results['state'][1]['result'][1]['keys'], dict):
                        raise TypeError("(string * string) list", repr(results['state'][1]['result'][1]['keys']))
                    for tmp_52, tmp_53 in results['state'][1]['result'][1]['keys'].items():
                        if not isinstance(tmp_52, (str, unicode)):
                            raise TypeError("string", repr(tmp_52))
                        if not isinstance(tmp_53, (str, unicode)):
                            raise TypeError("string", repr(tmp_53))
                    if 'volume_type' in results['state'][1]['result'][1]:
                        if results['state'][1]['result'][1]['volume_type'][0] not in ["Data", "CBT_Metadata", "Data_and_CBT_Metadata"]:
                            raise TypeError("| Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *)", repr(results['state'][1]['result'][1]['volume_type']))
                    if 'cbt_enabled' in results['state'][1]['result'][1]:
                        if not isinstance(results['state'][1]['result'][1]['cbt_enabled'], bool):
                            raise TypeError("bool", repr(results['state'][1]['result'][1]['cbt_enabled']))
        elif results['state'][0] == 'Failed':
            if not isinstance(results['state'][1], (str, unicode)):
                raise TypeError("string", repr(results['state'][1]))
        return results

    def cancel(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "id" not in args:
            raise UnmarshalException('argument missing', 'id', '')
        id = args["id"]
        if not isinstance(id, (str, unicode)):
            raise TypeError("string", repr(id))
        results = self._impl.cancel(dbg, id)
        return results

    def destroy(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "id" not in args:
            raise UnmarshalException('argument missing', 'id', '')
        id = args["id"]
        if not isinstance(id, (str, unicode)):
            raise TypeError("string", repr(id))
        results = self._impl.destroy(dbg, id)
        return results

    def ls(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        results = self._impl.ls(dbg)
        if not isinstance(results, list):
            raise TypeError("string list", repr(results))
        for tmp_55 in results:
            if not isinstance(tmp_55, (str, unicode)):
                raise TypeError("string", repr(tmp_55))
        return results

    def _dispatch(self, method, params):
        """type check inputs, call implementation, type check outputs and return"""
        args = params[0]
        return success(self._dispatcher_dict[method](args))


class Task_skeleton(object):
    """
    The task interface is for querying the status of asynchronous
    tasks. All long-running operations are associated with tasks,
    including copying and mirroring of data.
    """

    def __init__(self):
        pass

    def stat(self, dbg, id):
        """
        [stat task_id] returns the status of the task
        """
        raise Unimplemented("Task.stat")

    def cancel(self, dbg, id):
        """
        [cancel task_id] performs a best-effort cancellation of an ongoing
        task. The effect of this should leave the system in one of two
        states: Either that the task has completed successfully, or that it
        had never been made at all. The call should return immediately and
        the status of the task can the be queried via the [stat] call.
        """
        raise Unimplemented("Task.cancel")

    def destroy(self, dbg, id):
        """
        [destroy task_id] should remove all traces of the task_id. This call
        should fail if the task is currently in progress.
        """
        raise Unimplemented("Task.destroy")

    def ls(self, dbg):
        """
        [ls] should return a list of all of the tasks the plugin is aware of.
        """
        raise Unimplemented("Task.ls")


class Task_test(object):
    """
    The task interface is for querying the status of asynchronous
    tasks. All long-running operations are associated with tasks,
    including copying and mirroring of data.
    """

    def __init__(self):
        pass

    def stat(self, dbg, id):
        """
        [stat task_id] returns the status of the task
        """
        return {"id": "string", "debug_info": "string", "ctime": 1.1, "state": None}

    def cancel(self, dbg, id):
        """
        [cancel task_id] performs a best-effort cancellation of an ongoing
        task. The effect of this should leave the system in one of two
        states: Either that the task has completed successfully, or that it
        had never been made at all. The call should return immediately and
        the status of the task can the be queried via the [stat] call.
        """

    def destroy(self, dbg, id):
        """
        [destroy task_id] should remove all traces of the task_id. This call
        should fail if the task is currently in progress.
        """

    def ls(self, dbg):
        """
        [ls] should return a list of all of the tasks the plugin is aware of.
        """
        return ["string"]


class Task_commandline(object):
    """Parse command-line arguments and call an implementation."""

    def __init__(self, impl):
        self.impl = impl
        self.dispatcher = Task_server_dispatcher(self.impl)

    def _parse_stat(self):
        """
        [stat task_id] returns the status of the task
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[stat task_id] returns the status of the task')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('id', action='store', help='Unique identifier for a task.')
        return vars(parser.parse_args())

    def _parse_cancel(self):
        """
        [cancel task_id] performs a best-effort cancellation of an ongoing
        task. The effect of this should leave the system in one of two
        states: Either that the task has completed successfully, or that it
        had never been made at all. The call should return immediately and
        the status of the task can the be queried via the [stat] call.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[cancel task_id] performs a best-effort cancellation of an ongoing  task. The effect of this should leave the system in one of two  states: Either that the task has completed successfully, or that it  had never been made at all. The call should return immediately and  the status of the task can the be queried via the [stat] call.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('id', action='store', help='Unique identifier for a task.')
        return vars(parser.parse_args())

    def _parse_destroy(self):
        """
        [destroy task_id] should remove all traces of the task_id. This call
        should fail if the task is currently in progress.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[destroy task_id] should remove all traces of the task_id. This call  should fail if the task is currently in progress.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('id', action='store', help='Unique identifier for a task.')
        return vars(parser.parse_args())

    def _parse_ls(self):
        """
        [ls] should return a list of all of the tasks the plugin is aware of.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[ls] should return a list of all of the tasks the plugin is aware of.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        return vars(parser.parse_args())

    def stat(self):
        """
        [stat task_id] returns the status of the task
        """
        use_json = False
        try:
            request = self._parse_stat()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.stat(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def cancel(self):
        """
        [cancel task_id] performs a best-effort cancellation of an ongoing
        task. The effect of this should leave the system in one of two
        states: Either that the task has completed successfully, or that it
        had never been made at all. The call should return immediately and
        the status of the task can the be queried via the [stat] call.
        """
        use_json = False
        try:
            request = self._parse_cancel()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.cancel(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def destroy(self):
        """
        [destroy task_id] should remove all traces of the task_id. This call
        should fail if the task is currently in progress.
        """
        use_json = False
        try:
            request = self._parse_destroy()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.destroy(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def ls(self):
        """
        [ls] should return a list of all of the tasks the plugin is aware of.
        """
        use_json = False
        try:
            request = self._parse_ls()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.ls(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn


class task_server_dispatcher(object):
    """Demux calls to individual interface server_dispatchers"""

    def __init__(self, Task=None):
        self.Task = Task
        self._dispatcher_dict = {
            "Task": self.Task._dispatch
        }

    def _dispatch(self, method, params):
        try:
            logging.log("method = %s params = %s", method, repr(params))
            class_ = method.split('.')[0]
            if class_ in self._dispatcher_dict:
                return self._dispatcher_dict[class_](method, params)
            raise UnknownMethod(method)
        except Rpc_light_failure as rpc_exn:
            logging.log("caught %s", rpc_exn)
            traceback.print_exc()
            logging.log("returning %s", repr(rpc_exn.failure()))
            return rpc_exn.failure()
        except Exception as exn:
            logging.log("caught %s", exn)
            traceback.print_exc()
            return InternalError(get_str(exn)).failure()


class task_server_test(task_server_dispatcher):
    """Create a server which will respond to all calls, returning arbitrary values. This is intended as a marshal/unmarshal test."""

    def __init__(self):
        task_server_dispatcher.__init__(self, Task_server_dispatcher(Task_test()))
