"""Bindings generated for interface volume by rpclib"""

from __future__ import print_function, division

import argparse
import json
import logging
import sys
import traceback

get_str = str
if sys.version_info[0] > 2:
    long = int
    unicode = str
    str = bytes

from xapi import *


class Sr_not_attached(Rpc_light_failure):
    """
    An SR must be attached in order to access volumes
    """

    def __init__(self, arg_0):
        super(Sr_not_attached, self).__init__("Sr_not_attached", [arg_0])
        if not isinstance(arg_0, (str, unicode)):
            raise TypeError("string", repr(arg_0))
        self.arg_0 = arg_0


class SR_does_not_exist(Rpc_light_failure):
    """
    The specified SR could not be found
    """

    def __init__(self, arg_0):
        super(SR_does_not_exist, self).__init__("SR_does_not_exist", [arg_0])
        if not isinstance(arg_0, (str, unicode)):
            raise TypeError("string", repr(arg_0))
        self.arg_0 = arg_0


class Volume_does_not_exist(Rpc_light_failure):
    """
    The specified volume could not be found in the SR
    """

    def __init__(self, arg_0):
        super(Volume_does_not_exist, self).__init__("Volume_does_not_exist", [arg_0])
        if not isinstance(arg_0, (str, unicode)):
            raise TypeError("string", repr(arg_0))
        self.arg_0 = arg_0


class Cancelled(Rpc_light_failure):
    """
    The operation has been cancelled
    """

    def __init__(self, arg_0):
        super(Cancelled, self).__init__("Cancelled", [arg_0])
        if not isinstance(arg_0, (str, unicode)):
            raise TypeError("string", repr(arg_0))
        self.arg_0 = arg_0


class Activated_on_another_host(Rpc_light_failure):
    """
    The Volume is already active on another host
    """

    def __init__(self, arg_0):
        super(Activated_on_another_host, self).__init__("Activated_on_another_host", [arg_0])
        if not isinstance(arg_0, (str, unicode)):
            raise TypeError("string", repr(arg_0))
        self.arg_0 = arg_0


class SR_server_dispatcher(object):
    """
    Operations which act on Storage Repositories
    """

    def __init__(self, impl):
        """impl is a proxy object whose methods contain the implementation"""
        self._impl = impl
        self._dispatcher_dict = {
            "SR.probe": self.probe,
            "SR.create": self.create,
            "SR.attach": self.attach,
            "SR.detach": self.detach,
            "SR.destroy": self.destroy,
            "SR.stat": self.stat,
            "SR.set_name": self.set_name,
            "SR.set_description": self.set_description,
            "SR.ls": self.ls
        }

    def probe(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "configuration" not in args:
            raise UnmarshalException('argument missing', 'configuration', '')
        configuration = args["configuration"]
        if not isinstance(configuration, dict):
            raise TypeError("(string * string) list", repr(configuration))
        for tmp_17, tmp_18 in configuration.items():
            if not isinstance(tmp_17, (str, unicode)):
                raise TypeError("string", repr(tmp_17))
            if not isinstance(tmp_18, (str, unicode)):
                raise TypeError("string", repr(tmp_18))
        results = self._impl.probe(dbg, configuration)
        if not isinstance(results, list):
            raise TypeError("{ configuration: (string * string) list; complete: bool; sr: { sr: string; name: string; uuid: string option; description: string; free_space: int64; total_space: int64; datasources: string list; clustered: bool; health: | Healthy (string) (** Storage is fully available *) | Recovering (string) (** Storage is busy recovering, e.g. rebuilding mirrors *) | Unreachable (string) (** Storage is unreachable but may be recoverable with admin intervention *) | Unavailable (string) (** Storage is unavailable, a host reboot will be required *); } option; extra_info: (string * string) list; } list", repr(results))
        for tmp_11 in results:
            if not isinstance(tmp_11['configuration'], dict):
                raise TypeError("(string * string) list", repr(tmp_11['configuration']))
            for tmp_15, tmp_16 in tmp_11['configuration'].items():
                if not isinstance(tmp_15, (str, unicode)):
                    raise TypeError("string", repr(tmp_15))
                if not isinstance(tmp_16, (str, unicode)):
                    raise TypeError("string", repr(tmp_16))
            if not isinstance(tmp_11['complete'], bool):
                raise TypeError("bool", repr(tmp_11['complete']))
            if 'sr' in tmp_11:
                if not isinstance(tmp_11['sr']['sr'], (str, unicode)):
                    raise TypeError("string", repr(tmp_11['sr']['sr']))
                if not isinstance(tmp_11['sr']['name'], (str, unicode)):
                    raise TypeError("string", repr(tmp_11['sr']['name']))
                if 'uuid' in tmp_11['sr']:
                    if not isinstance(tmp_11['sr']['uuid'], (str, unicode)):
                        raise TypeError("string", repr(tmp_11['sr']['uuid']))
                if not isinstance(tmp_11['sr']['description'], (str, unicode)):
                    raise TypeError("string", repr(tmp_11['sr']['description']))
                if not isinstance(tmp_11['sr']['free_space'], (int, long)):
                    raise TypeError("int64", repr(tmp_11['sr']['free_space']))
                if not isinstance(tmp_11['sr']['total_space'], (int, long)):
                    raise TypeError("int64", repr(tmp_11['sr']['total_space']))
                if not isinstance(tmp_11['sr']['datasources'], list):
                    raise TypeError("string list", repr(tmp_11['sr']['datasources']))
                for tmp_14 in tmp_11['sr']['datasources']:
                    if not isinstance(tmp_14, (str, unicode)):
                        raise TypeError("string", repr(tmp_14))
                if not isinstance(tmp_11['sr']['clustered'], bool):
                    raise TypeError("bool", repr(tmp_11['sr']['clustered']))
                if tmp_11['sr']['health'][0] not in ["Healthy", "Recovering", "Unreachable", "Unavailable"]:
                    raise TypeError("| Healthy (string) (** Storage is fully available *) | Recovering (string) (** Storage is busy recovering, e.g. rebuilding mirrors *) | Unreachable (string) (** Storage is unreachable but may be recoverable with admin intervention *) | Unavailable (string) (** Storage is unavailable, a host reboot will be required *)", repr(tmp_11['sr']['health']))
                if tmp_11['sr']['health'][0] == 'Healthy':
                    if not isinstance(tmp_11['sr']['health'][1], (str, unicode)):
                        raise TypeError("string", repr(tmp_11['sr']['health'][1]))
                elif tmp_11['sr']['health'][0] == 'Recovering':
                    if not isinstance(tmp_11['sr']['health'][1], (str, unicode)):
                        raise TypeError("string", repr(tmp_11['sr']['health'][1]))
                elif tmp_11['sr']['health'][0] == 'Unreachable':
                    if not isinstance(tmp_11['sr']['health'][1], (str, unicode)):
                        raise TypeError("string", repr(tmp_11['sr']['health'][1]))
                elif tmp_11['sr']['health'][0] == 'Unavailable':
                    if not isinstance(tmp_11['sr']['health'][1], (str, unicode)):
                        raise TypeError("string", repr(tmp_11['sr']['health'][1]))
            if not isinstance(tmp_11['extra_info'], dict):
                raise TypeError("(string * string) list", repr(tmp_11['extra_info']))
            for tmp_12, tmp_13 in tmp_11['extra_info'].items():
                if not isinstance(tmp_12, (str, unicode)):
                    raise TypeError("string", repr(tmp_12))
                if not isinstance(tmp_13, (str, unicode)):
                    raise TypeError("string", repr(tmp_13))
        return results

    def create(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "uuid" not in args:
            raise UnmarshalException('argument missing', 'uuid', '')
        uuid = args["uuid"]
        if not isinstance(uuid, (str, unicode)):
            raise TypeError("string", repr(uuid))
        if "configuration" not in args:
            raise UnmarshalException('argument missing', 'configuration', '')
        configuration = args["configuration"]
        if not isinstance(configuration, dict):
            raise TypeError("(string * string) list", repr(configuration))
        for tmp_21, tmp_22 in configuration.items():
            if not isinstance(tmp_21, (str, unicode)):
                raise TypeError("string", repr(tmp_21))
            if not isinstance(tmp_22, (str, unicode)):
                raise TypeError("string", repr(tmp_22))
        if "name" not in args:
            raise UnmarshalException('argument missing', 'name', '')
        name = args["name"]
        if not isinstance(name, (str, unicode)):
            raise TypeError("string", repr(name))
        if "description" not in args:
            raise UnmarshalException('argument missing', 'description', '')
        description = args["description"]
        if not isinstance(description, (str, unicode)):
            raise TypeError("string", repr(description))
        results = self._impl.create(dbg, uuid, configuration, name, description)
        if not isinstance(results, dict):
            raise TypeError("(string * string) list", repr(results))
        for tmp_19, tmp_20 in results.items():
            if not isinstance(tmp_19, (str, unicode)):
                raise TypeError("string", repr(tmp_19))
            if not isinstance(tmp_20, (str, unicode)):
                raise TypeError("string", repr(tmp_20))
        return results

    def attach(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "configuration" not in args:
            raise UnmarshalException('argument missing', 'configuration', '')
        configuration = args["configuration"]
        if not isinstance(configuration, dict):
            raise TypeError("(string * string) list", repr(configuration))
        for tmp_23, tmp_24 in configuration.items():
            if not isinstance(tmp_23, (str, unicode)):
                raise TypeError("string", repr(tmp_23))
            if not isinstance(tmp_24, (str, unicode)):
                raise TypeError("string", repr(tmp_24))
        results = self._impl.attach(dbg, configuration)
        if not isinstance(results, (str, unicode)):
            raise TypeError("string", repr(results))
        return results

    def detach(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        results = self._impl.detach(dbg, sr)
        return results

    def destroy(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        results = self._impl.destroy(dbg, sr)
        return results

    def stat(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        results = self._impl.stat(dbg, sr)
        if not isinstance(results['sr'], (str, unicode)):
            raise TypeError("string", repr(results['sr']))
        if not isinstance(results['name'], (str, unicode)):
            raise TypeError("string", repr(results['name']))
        if 'uuid' in results:
            if not isinstance(results['uuid'], (str, unicode)):
                raise TypeError("string", repr(results['uuid']))
        if not isinstance(results['description'], (str, unicode)):
            raise TypeError("string", repr(results['description']))
        if not isinstance(results['free_space'], (int, long)):
            raise TypeError("int64", repr(results['free_space']))
        if not isinstance(results['total_space'], (int, long)):
            raise TypeError("int64", repr(results['total_space']))
        if not isinstance(results['datasources'], list):
            raise TypeError("string list", repr(results['datasources']))
        for tmp_25 in results['datasources']:
            if not isinstance(tmp_25, (str, unicode)):
                raise TypeError("string", repr(tmp_25))
        if not isinstance(results['clustered'], bool):
            raise TypeError("bool", repr(results['clustered']))
        if results['health'][0] not in ["Healthy", "Recovering", "Unreachable", "Unavailable"]:
            raise TypeError("| Healthy (string) (** Storage is fully available *) | Recovering (string) (** Storage is busy recovering, e.g. rebuilding mirrors *) | Unreachable (string) (** Storage is unreachable but may be recoverable with admin intervention *) | Unavailable (string) (** Storage is unavailable, a host reboot will be required *)", repr(results['health']))
        if results['health'][0] == 'Healthy':
            if not isinstance(results['health'][1], (str, unicode)):
                raise TypeError("string", repr(results['health'][1]))
        elif results['health'][0] == 'Recovering':
            if not isinstance(results['health'][1], (str, unicode)):
                raise TypeError("string", repr(results['health'][1]))
        elif results['health'][0] == 'Unreachable':
            if not isinstance(results['health'][1], (str, unicode)):
                raise TypeError("string", repr(results['health'][1]))
        elif results['health'][0] == 'Unavailable':
            if not isinstance(results['health'][1], (str, unicode)):
                raise TypeError("string", repr(results['health'][1]))
        return results

    def set_name(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "new_name" not in args:
            raise UnmarshalException('argument missing', 'new_name', '')
        new_name = args["new_name"]
        if not isinstance(new_name, (str, unicode)):
            raise TypeError("string", repr(new_name))
        results = self._impl.set_name(dbg, sr, new_name)
        return results

    def set_description(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "new_description" not in args:
            raise UnmarshalException('argument missing', 'new_description', '')
        new_description = args["new_description"]
        if not isinstance(new_description, (str, unicode)):
            raise TypeError("string", repr(new_description))
        results = self._impl.set_description(dbg, sr, new_description)
        return results

    def ls(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        results = self._impl.ls(dbg, sr)
        if not isinstance(results, list):
            raise TypeError("{ key: string; uuid: string option; name: string; description: string; read_write: bool; sharable: bool; virtual_size: int64; physical_utilisation: int64; uri: string list; keys: (string * string) list; volume_type: | Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *) option; cbt_enabled: bool option; } list", repr(results))
        for tmp_26 in results:
            if not isinstance(tmp_26['key'], (str, unicode)):
                raise TypeError("string", repr(tmp_26['key']))
            if 'uuid' in tmp_26:
                if not isinstance(tmp_26['uuid'], (str, unicode)):
                    raise TypeError("string", repr(tmp_26['uuid']))
            if not isinstance(tmp_26['name'], (str, unicode)):
                raise TypeError("string", repr(tmp_26['name']))
            if not isinstance(tmp_26['description'], (str, unicode)):
                raise TypeError("string", repr(tmp_26['description']))
            if not isinstance(tmp_26['read_write'], bool):
                raise TypeError("bool", repr(tmp_26['read_write']))
            if not isinstance(tmp_26['sharable'], bool):
                raise TypeError("bool", repr(tmp_26['sharable']))
            if not isinstance(tmp_26['virtual_size'], (int, long)):
                raise TypeError("int64", repr(tmp_26['virtual_size']))
            if not isinstance(tmp_26['physical_utilisation'], (int, long)):
                raise TypeError("int64", repr(tmp_26['physical_utilisation']))
            if not isinstance(tmp_26['uri'], list):
                raise TypeError("string list", repr(tmp_26['uri']))
            for tmp_29 in tmp_26['uri']:
                if not isinstance(tmp_29, (str, unicode)):
                    raise TypeError("string", repr(tmp_29))
            if not isinstance(tmp_26['keys'], dict):
                raise TypeError("(string * string) list", repr(tmp_26['keys']))
            for tmp_27, tmp_28 in tmp_26['keys'].items():
                if not isinstance(tmp_27, (str, unicode)):
                    raise TypeError("string", repr(tmp_27))
                if not isinstance(tmp_28, (str, unicode)):
                    raise TypeError("string", repr(tmp_28))
            if 'volume_type' in tmp_26:
                if tmp_26['volume_type'][0] not in ["Data", "CBT_Metadata", "Data_and_CBT_Metadata"]:
                    raise TypeError("| Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *)", repr(tmp_26['volume_type']))
            if 'cbt_enabled' in tmp_26:
                if not isinstance(tmp_26['cbt_enabled'], bool):
                    raise TypeError("bool", repr(tmp_26['cbt_enabled']))
        return results

    def _dispatch(self, method, params):
        """type check inputs, call implementation, type check outputs and return"""
        args = params[0]
        return success(self._dispatcher_dict[method](args))


class SR_skeleton(object):
    """
    Operations which act on Storage Repositories
    """

    def __init__(self):
        pass

    def probe(self, dbg, configuration):
        """
        [probe configuration]: can be used iteratively to narrow down configurations
        to use with SR.create, or to find existing SRs on the backing storage
        """
        raise Unimplemented("SR.probe")

    def create(self, dbg, uuid, configuration, name, description):
        """
        [create uuid configuration name description]: creates a fresh SR
        """
        raise Unimplemented("SR.create")

    def attach(self, dbg, configuration):
        """
        [attach configuration]: attaches the SR to the local host. Once an SR is
        attached then volumes may be manipulated.
        """
        raise Unimplemented("SR.attach")

    def detach(self, dbg, sr):
        """
        [detach sr]: detaches the SR, clearing up any associated resources.
        Once the SR is detached then volumes may not be manipulated.
        """
        raise Unimplemented("SR.detach")

    def destroy(self, dbg, sr):
        """
        [destroy sr]: destroys the [sr] and deletes any volumes associated
        with it. Note that an SR must be attached to be destroyed; otherwise
        Sr_not_attached is thrown.
        """
        raise Unimplemented("SR.destroy")

    def stat(self, dbg, sr):
        """
        [stat sr] returns summary metadata associated with [sr]. Note this
        call does not return details of sub-volumes, see SR.ls.
        """
        raise Unimplemented("SR.stat")

    def set_name(self, dbg, sr, new_name):
        """
        [set_name sr new_name] changes the name of [sr]
        """
        raise Unimplemented("SR.set_name")

    def set_description(self, dbg, sr, new_description):
        """
        [set_description sr new_description] changes the description of [sr]
        """
        raise Unimplemented("SR.set_description")

    def ls(self, dbg, sr):
        """
        [ls sr] returns a list of volumes contained within an attached SR.
        """
        raise Unimplemented("SR.ls")


class SR_test(object):
    """
    Operations which act on Storage Repositories
    """

    def __init__(self):
        pass

    def probe(self, dbg, configuration):
        """
        [probe configuration]: can be used iteratively to narrow down configurations
        to use with SR.create, or to find existing SRs on the backing storage
        """
        return [{"configuration": {"string": "string"}, "complete": True, "sr": None, "extra_info": {"string": "string"}}]

    def create(self, dbg, uuid, configuration, name, description):
        """
        [create uuid configuration name description]: creates a fresh SR
        """
        return {"string": "string"}

    def attach(self, dbg, configuration):
        """
        [attach configuration]: attaches the SR to the local host. Once an SR is
        attached then volumes may be manipulated.
        """
        return "string"

    def detach(self, dbg, sr):
        """
        [detach sr]: detaches the SR, clearing up any associated resources.
        Once the SR is detached then volumes may not be manipulated.
        """

    def destroy(self, dbg, sr):
        """
        [destroy sr]: destroys the [sr] and deletes any volumes associated
        with it. Note that an SR must be attached to be destroyed; otherwise
        Sr_not_attached is thrown.
        """

    def stat(self, dbg, sr):
        """
        [stat sr] returns summary metadata associated with [sr]. Note this
        call does not return details of sub-volumes, see SR.ls.
        """
        return {"sr": "string", "name": "string", "uuid": None, "description": "string", "free_space": long(0), "total_space": long(0), "datasources": ["string"], "clustered": True, "health": None}

    def set_name(self, dbg, sr, new_name):
        """
        [set_name sr new_name] changes the name of [sr]
        """

    def set_description(self, dbg, sr, new_description):
        """
        [set_description sr new_description] changes the description of [sr]
        """

    def ls(self, dbg, sr):
        """
        [ls sr] returns a list of volumes contained within an attached SR.
        """
        return [{"key": "string", "uuid": None, "name": "string", "description": "string", "read_write": True, "sharable": True, "virtual_size": long(0), "physical_utilisation": long(0), "uri": ["string"], "keys": {"string": "string"}, "volume_type": None, "cbt_enabled": None}]


class SR_commandline(object):
    """Parse command-line arguments and call an implementation."""

    def __init__(self, impl):
        self.impl = impl
        self.dispatcher = SR_server_dispatcher(self.impl)

    def _parse_probe(self):
        """
        [probe configuration]: can be used iteratively to narrow down configurations
        to use with SR.create, or to find existing SRs on the backing storage
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[probe configuration]: can be used iteratively to narrow down configurations to use with SR.create, or to find existing SRs on the backing storage')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('--configuration', default={}, nargs=2, action=ListAction, help='Plugin-specific configuration which describes where and how to locate the storage repository. This may include the physical block device name, a remote NFS server and path or an RBD storage pool.')
        return vars(parser.parse_args())

    def _parse_create(self):
        """
        [create uuid configuration name description]: creates a fresh SR
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[create uuid configuration name description]: creates a fresh SR')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('uuid', action='store', help='A uuid to associate with the SR.')
        parser.add_argument('--configuration', default={}, nargs=2, action=ListAction, help='Plugin-specific configuration which describes where and how to locate the storage repository. This may include the physical block device name, a remote NFS server and path or an RBD storage pool.')
        parser.add_argument('name', action='store', help='Human-readable name for the SR')
        parser.add_argument('description', action='store', help='Human-readable description for the SR')
        return vars(parser.parse_args())

    def _parse_attach(self):
        """
        [attach configuration]: attaches the SR to the local host. Once an SR is
        attached then volumes may be manipulated.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[attach configuration]: attaches the SR to the local host. Once an SR is  attached then volumes may be manipulated.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('--configuration', default={}, nargs=2, action=ListAction, help='Plugin-specific configuration which describes where and how to locate the storage repository. This may include the physical block device name, a remote NFS server and path or an RBD storage pool.')
        return vars(parser.parse_args())

    def _parse_detach(self):
        """
        [detach sr]: detaches the SR, clearing up any associated resources.
        Once the SR is detached then volumes may not be manipulated.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[detach sr]: detaches the SR, clearing up any associated resources.  Once the SR is detached then volumes may not be manipulated.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        return vars(parser.parse_args())

    def _parse_destroy(self):
        """
        [destroy sr]: destroys the [sr] and deletes any volumes associated
        with it. Note that an SR must be attached to be destroyed; otherwise
        Sr_not_attached is thrown.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[destroy sr]: destroys the [sr] and deletes any volumes associated  with it. Note that an SR must be attached to be destroyed; otherwise  Sr_not_attached is thrown.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        return vars(parser.parse_args())

    def _parse_stat(self):
        """
        [stat sr] returns summary metadata associated with [sr]. Note this
        call does not return details of sub-volumes, see SR.ls.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[stat sr] returns summary metadata associated with [sr]. Note this  call does not return details of sub-volumes, see SR.ls.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        return vars(parser.parse_args())

    def _parse_set_name(self):
        """
        [set_name sr new_name] changes the name of [sr]
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[set_name sr new_name] changes the name of [sr]')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('new_name', action='store', help='The new name of the SR')
        return vars(parser.parse_args())

    def _parse_set_description(self):
        """
        [set_description sr new_description] changes the description of [sr]
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[set_description sr new_description] changes the description of [sr]')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('new_description', action='store', help='The new description for the SR')
        return vars(parser.parse_args())

    def _parse_ls(self):
        """
        [ls sr] returns a list of volumes contained within an attached SR.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[ls sr] returns a list of volumes contained within an attached SR.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        return vars(parser.parse_args())

    def probe(self):
        """
        [probe configuration]: can be used iteratively to narrow down configurations
        to use with SR.create, or to find existing SRs on the backing storage
        """
        use_json = False
        try:
            request = self._parse_probe()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.probe(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def create(self):
        """
        [create uuid configuration name description]: creates a fresh SR
        """
        use_json = False
        try:
            request = self._parse_create()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.create(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def attach(self):
        """
        [attach configuration]: attaches the SR to the local host. Once an SR is
        attached then volumes may be manipulated.
        """
        use_json = False
        try:
            request = self._parse_attach()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.attach(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def detach(self):
        """
        [detach sr]: detaches the SR, clearing up any associated resources.
        Once the SR is detached then volumes may not be manipulated.
        """
        use_json = False
        try:
            request = self._parse_detach()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.detach(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def destroy(self):
        """
        [destroy sr]: destroys the [sr] and deletes any volumes associated
        with it. Note that an SR must be attached to be destroyed; otherwise
        Sr_not_attached is thrown.
        """
        use_json = False
        try:
            request = self._parse_destroy()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.destroy(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def stat(self):
        """
        [stat sr] returns summary metadata associated with [sr]. Note this
        call does not return details of sub-volumes, see SR.ls.
        """
        use_json = False
        try:
            request = self._parse_stat()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.stat(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def set_name(self):
        """
        [set_name sr new_name] changes the name of [sr]
        """
        use_json = False
        try:
            request = self._parse_set_name()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.set_name(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def set_description(self):
        """
        [set_description sr new_description] changes the description of [sr]
        """
        use_json = False
        try:
            request = self._parse_set_description()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.set_description(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def ls(self):
        """
        [ls sr] returns a list of volumes contained within an attached SR.
        """
        use_json = False
        try:
            request = self._parse_ls()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.ls(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn


class Volume_server_dispatcher(object):
    """
    Operations which operate on volumes (also known as
    Virtual Disk Images)
    """

    def __init__(self, impl):
        """impl is a proxy object whose methods contain the implementation"""
        self._impl = impl
        self._dispatcher_dict = {
            "Volume.create": self.create,
            "Volume.snapshot": self.snapshot,
            "Volume.clone": self.clone,
            "Volume.copy": self.copy,
            "Volume.destroy": self.destroy,
            "Volume.set_name": self.set_name,
            "Volume.set_description": self.set_description,
            "Volume.set": self.set,
            "Volume.unset": self.unset,
            "Volume.resize": self.resize,
            "Volume.stat": self.stat,
            "Volume.compare": self.compare,
            "Volume.similar_content": self.similar_content,
            "Volume.enable_cbt": self.enable_cbt,
            "Volume.disable_cbt": self.disable_cbt,
            "Volume.data_destroy": self.data_destroy,
            "Volume.list_changed_blocks": self.list_changed_blocks,
            "Volume.compose": self.compose
        }

    def create(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "name" not in args:
            raise UnmarshalException('argument missing', 'name', '')
        name = args["name"]
        if not isinstance(name, (str, unicode)):
            raise TypeError("string", repr(name))
        if "description" not in args:
            raise UnmarshalException('argument missing', 'description', '')
        description = args["description"]
        if not isinstance(description, (str, unicode)):
            raise TypeError("string", repr(description))
        if "size" not in args:
            raise UnmarshalException('argument missing', 'size', '')
        size = args["size"]
        if not isinstance(size, (int, long)):
            raise TypeError("int64", repr(size))
        if "sharable" not in args:
            raise UnmarshalException('argument missing', 'sharable', '')
        sharable = args["sharable"]
        if not isinstance(sharable, bool):
            raise TypeError("bool", repr(sharable))
        results = self._impl.create(dbg, sr, name, description, size, sharable)
        if not isinstance(results['key'], (str, unicode)):
            raise TypeError("string", repr(results['key']))
        if 'uuid' in results:
            if not isinstance(results['uuid'], (str, unicode)):
                raise TypeError("string", repr(results['uuid']))
        if not isinstance(results['name'], (str, unicode)):
            raise TypeError("string", repr(results['name']))
        if not isinstance(results['description'], (str, unicode)):
            raise TypeError("string", repr(results['description']))
        if not isinstance(results['read_write'], bool):
            raise TypeError("bool", repr(results['read_write']))
        if not isinstance(results['sharable'], bool):
            raise TypeError("bool", repr(results['sharable']))
        if not isinstance(results['virtual_size'], (int, long)):
            raise TypeError("int64", repr(results['virtual_size']))
        if not isinstance(results['physical_utilisation'], (int, long)):
            raise TypeError("int64", repr(results['physical_utilisation']))
        if not isinstance(results['uri'], list):
            raise TypeError("string list", repr(results['uri']))
        for tmp_32 in results['uri']:
            if not isinstance(tmp_32, (str, unicode)):
                raise TypeError("string", repr(tmp_32))
        if not isinstance(results['keys'], dict):
            raise TypeError("(string * string) list", repr(results['keys']))
        for tmp_30, tmp_31 in results['keys'].items():
            if not isinstance(tmp_30, (str, unicode)):
                raise TypeError("string", repr(tmp_30))
            if not isinstance(tmp_31, (str, unicode)):
                raise TypeError("string", repr(tmp_31))
        if 'volume_type' in results:
            if results['volume_type'][0] not in ["Data", "CBT_Metadata", "Data_and_CBT_Metadata"]:
                raise TypeError("| Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *)", repr(results['volume_type']))
        if 'cbt_enabled' in results:
            if not isinstance(results['cbt_enabled'], bool):
                raise TypeError("bool", repr(results['cbt_enabled']))
        return results

    def snapshot(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        results = self._impl.snapshot(dbg, sr, key)
        if not isinstance(results['key'], (str, unicode)):
            raise TypeError("string", repr(results['key']))
        if 'uuid' in results:
            if not isinstance(results['uuid'], (str, unicode)):
                raise TypeError("string", repr(results['uuid']))
        if not isinstance(results['name'], (str, unicode)):
            raise TypeError("string", repr(results['name']))
        if not isinstance(results['description'], (str, unicode)):
            raise TypeError("string", repr(results['description']))
        if not isinstance(results['read_write'], bool):
            raise TypeError("bool", repr(results['read_write']))
        if not isinstance(results['sharable'], bool):
            raise TypeError("bool", repr(results['sharable']))
        if not isinstance(results['virtual_size'], (int, long)):
            raise TypeError("int64", repr(results['virtual_size']))
        if not isinstance(results['physical_utilisation'], (int, long)):
            raise TypeError("int64", repr(results['physical_utilisation']))
        if not isinstance(results['uri'], list):
            raise TypeError("string list", repr(results['uri']))
        for tmp_35 in results['uri']:
            if not isinstance(tmp_35, (str, unicode)):
                raise TypeError("string", repr(tmp_35))
        if not isinstance(results['keys'], dict):
            raise TypeError("(string * string) list", repr(results['keys']))
        for tmp_33, tmp_34 in results['keys'].items():
            if not isinstance(tmp_33, (str, unicode)):
                raise TypeError("string", repr(tmp_33))
            if not isinstance(tmp_34, (str, unicode)):
                raise TypeError("string", repr(tmp_34))
        if 'volume_type' in results:
            if results['volume_type'][0] not in ["Data", "CBT_Metadata", "Data_and_CBT_Metadata"]:
                raise TypeError("| Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *)", repr(results['volume_type']))
        if 'cbt_enabled' in results:
            if not isinstance(results['cbt_enabled'], bool):
                raise TypeError("bool", repr(results['cbt_enabled']))
        return results

    def clone(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        results = self._impl.clone(dbg, sr, key)
        if not isinstance(results['key'], (str, unicode)):
            raise TypeError("string", repr(results['key']))
        if 'uuid' in results:
            if not isinstance(results['uuid'], (str, unicode)):
                raise TypeError("string", repr(results['uuid']))
        if not isinstance(results['name'], (str, unicode)):
            raise TypeError("string", repr(results['name']))
        if not isinstance(results['description'], (str, unicode)):
            raise TypeError("string", repr(results['description']))
        if not isinstance(results['read_write'], bool):
            raise TypeError("bool", repr(results['read_write']))
        if not isinstance(results['sharable'], bool):
            raise TypeError("bool", repr(results['sharable']))
        if not isinstance(results['virtual_size'], (int, long)):
            raise TypeError("int64", repr(results['virtual_size']))
        if not isinstance(results['physical_utilisation'], (int, long)):
            raise TypeError("int64", repr(results['physical_utilisation']))
        if not isinstance(results['uri'], list):
            raise TypeError("string list", repr(results['uri']))
        for tmp_38 in results['uri']:
            if not isinstance(tmp_38, (str, unicode)):
                raise TypeError("string", repr(tmp_38))
        if not isinstance(results['keys'], dict):
            raise TypeError("(string * string) list", repr(results['keys']))
        for tmp_36, tmp_37 in results['keys'].items():
            if not isinstance(tmp_36, (str, unicode)):
                raise TypeError("string", repr(tmp_36))
            if not isinstance(tmp_37, (str, unicode)):
                raise TypeError("string", repr(tmp_37))
        if 'volume_type' in results:
            if results['volume_type'][0] not in ["Data", "CBT_Metadata", "Data_and_CBT_Metadata"]:
                raise TypeError("| Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *)", repr(results['volume_type']))
        if 'cbt_enabled' in results:
            if not isinstance(results['cbt_enabled'], bool):
                raise TypeError("bool", repr(results['cbt_enabled']))
        return results

    def copy(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        if "dest_sr" not in args:
            raise UnmarshalException('argument missing', 'dest_sr', '')
        dest_sr = args["dest_sr"]
        if not isinstance(dest_sr, (str, unicode)):
            raise TypeError("string", repr(dest_sr))
        results = self._impl.copy(dbg, sr, key, dest_sr)
        if not isinstance(results['key'], (str, unicode)):
            raise TypeError("string", repr(results['key']))
        if 'uuid' in results:
            if not isinstance(results['uuid'], (str, unicode)):
                raise TypeError("string", repr(results['uuid']))
        if not isinstance(results['name'], (str, unicode)):
            raise TypeError("string", repr(results['name']))
        if not isinstance(results['description'], (str, unicode)):
            raise TypeError("string", repr(results['description']))
        if not isinstance(results['read_write'], bool):
            raise TypeError("bool", repr(results['read_write']))
        if not isinstance(results['sharable'], bool):
            raise TypeError("bool", repr(results['sharable']))
        if not isinstance(results['virtual_size'], (int, long)):
            raise TypeError("int64", repr(results['virtual_size']))
        if not isinstance(results['physical_utilisation'], (int, long)):
            raise TypeError("int64", repr(results['physical_utilisation']))
        if not isinstance(results['uri'], list):
            raise TypeError("string list", repr(results['uri']))
        for tmp_41 in results['uri']:
            if not isinstance(tmp_41, (str, unicode)):
                raise TypeError("string", repr(tmp_41))
        if not isinstance(results['keys'], dict):
            raise TypeError("(string * string) list", repr(results['keys']))
        for tmp_39, tmp_40 in results['keys'].items():
            if not isinstance(tmp_39, (str, unicode)):
                raise TypeError("string", repr(tmp_39))
            if not isinstance(tmp_40, (str, unicode)):
                raise TypeError("string", repr(tmp_40))
        if 'volume_type' in results:
            if results['volume_type'][0] not in ["Data", "CBT_Metadata", "Data_and_CBT_Metadata"]:
                raise TypeError("| Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *)", repr(results['volume_type']))
        if 'cbt_enabled' in results:
            if not isinstance(results['cbt_enabled'], bool):
                raise TypeError("bool", repr(results['cbt_enabled']))
        return results

    def destroy(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        results = self._impl.destroy(dbg, sr, key)
        return results

    def set_name(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        if "new_name" not in args:
            raise UnmarshalException('argument missing', 'new_name', '')
        new_name = args["new_name"]
        if not isinstance(new_name, (str, unicode)):
            raise TypeError("string", repr(new_name))
        results = self._impl.set_name(dbg, sr, key, new_name)
        return results

    def set_description(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        if "new_description" not in args:
            raise UnmarshalException('argument missing', 'new_description', '')
        new_description = args["new_description"]
        if not isinstance(new_description, (str, unicode)):
            raise TypeError("string", repr(new_description))
        results = self._impl.set_description(dbg, sr, key, new_description)
        return results

    def set(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        if "k" not in args:
            raise UnmarshalException('argument missing', 'k', '')
        k = args["k"]
        if not isinstance(k, (str, unicode)):
            raise TypeError("string", repr(k))
        if "v" not in args:
            raise UnmarshalException('argument missing', 'v', '')
        v = args["v"]
        if not isinstance(v, (str, unicode)):
            raise TypeError("string", repr(v))
        results = self._impl.set(dbg, sr, key, k, v)
        return results

    def unset(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        if "k" not in args:
            raise UnmarshalException('argument missing', 'k', '')
        k = args["k"]
        if not isinstance(k, (str, unicode)):
            raise TypeError("string", repr(k))
        results = self._impl.unset(dbg, sr, key, k)
        return results

    def resize(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        if "new_size" not in args:
            raise UnmarshalException('argument missing', 'new_size', '')
        new_size = args["new_size"]
        if not isinstance(new_size, (int, long)):
            raise TypeError("int64", repr(new_size))
        results = self._impl.resize(dbg, sr, key, new_size)
        return results

    def stat(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        results = self._impl.stat(dbg, sr, key)
        if not isinstance(results['key'], (str, unicode)):
            raise TypeError("string", repr(results['key']))
        if 'uuid' in results:
            if not isinstance(results['uuid'], (str, unicode)):
                raise TypeError("string", repr(results['uuid']))
        if not isinstance(results['name'], (str, unicode)):
            raise TypeError("string", repr(results['name']))
        if not isinstance(results['description'], (str, unicode)):
            raise TypeError("string", repr(results['description']))
        if not isinstance(results['read_write'], bool):
            raise TypeError("bool", repr(results['read_write']))
        if not isinstance(results['sharable'], bool):
            raise TypeError("bool", repr(results['sharable']))
        if not isinstance(results['virtual_size'], (int, long)):
            raise TypeError("int64", repr(results['virtual_size']))
        if not isinstance(results['physical_utilisation'], (int, long)):
            raise TypeError("int64", repr(results['physical_utilisation']))
        if not isinstance(results['uri'], list):
            raise TypeError("string list", repr(results['uri']))
        for tmp_44 in results['uri']:
            if not isinstance(tmp_44, (str, unicode)):
                raise TypeError("string", repr(tmp_44))
        if not isinstance(results['keys'], dict):
            raise TypeError("(string * string) list", repr(results['keys']))
        for tmp_42, tmp_43 in results['keys'].items():
            if not isinstance(tmp_42, (str, unicode)):
                raise TypeError("string", repr(tmp_42))
            if not isinstance(tmp_43, (str, unicode)):
                raise TypeError("string", repr(tmp_43))
        if 'volume_type' in results:
            if results['volume_type'][0] not in ["Data", "CBT_Metadata", "Data_and_CBT_Metadata"]:
                raise TypeError("| Data (unit) (** Normal data volume *) | CBT_Metadata (unit) (** CBT Metadata only, data destroyed *) | Data_and_CBT_Metadata (unit) (** Both Data and CBT Metadata *)", repr(results['volume_type']))
        if 'cbt_enabled' in results:
            if not isinstance(results['cbt_enabled'], bool):
                raise TypeError("bool", repr(results['cbt_enabled']))
        return results

    def compare(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        if "key2" not in args:
            raise UnmarshalException('argument missing', 'key2', '')
        key2 = args["key2"]
        if not isinstance(key2, (str, unicode)):
            raise TypeError("string", repr(key2))
        results = self._impl.compare(dbg, sr, key, key2)
        if not isinstance(results['blocksize'], (int, long)):
            raise TypeError("int", repr(results['blocksize']))
        if not isinstance(results['ranges'], list):
            raise TypeError("(int64 * int64) list", repr(results['ranges']))
        for tmp_45 in results['ranges']:
            if not (isinstance(tmp_45, tuple) and len(tmp_45) == 2):
                raise TypeError("(int64 * int64)", repr(tmp_45))
            v1, v2 = tmp_45
            if not isinstance(v1, (int, long)):
                raise TypeError("int64", repr(v1))
            if not isinstance(v2, (int, long)):
                raise TypeError("int64", repr(v2))
        return results

    def similar_content(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        results = self._impl.similar_content(dbg, sr, key)
        if not isinstance(results, list):
            raise TypeError("string list", repr(results))
        for tmp_46 in results:
            if not isinstance(tmp_46, (str, unicode)):
                raise TypeError("string", repr(tmp_46))
        return results

    def enable_cbt(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        results = self._impl.enable_cbt(dbg, sr, key)
        return results

    def disable_cbt(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        results = self._impl.disable_cbt(dbg, sr, key)
        return results

    def data_destroy(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        results = self._impl.data_destroy(dbg, sr, key)
        return results

    def list_changed_blocks(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        if "key2" not in args:
            raise UnmarshalException('argument missing', 'key2', '')
        key2 = args["key2"]
        if not isinstance(key2, (str, unicode)):
            raise TypeError("string", repr(key2))
        if "offset" not in args:
            raise UnmarshalException('argument missing', 'offset', '')
        offset = args["offset"]
        if not isinstance(offset, (int, long)):
            raise TypeError("int64", repr(offset))
        if "length" not in args:
            raise UnmarshalException('argument missing', 'length', '')
        length = args["length"]
        if not isinstance(length, (int, long)):
            raise TypeError("int", repr(length))
        results = self._impl.list_changed_blocks(dbg, sr, key, key2, offset, length)
        if not isinstance(results['granularity'], (int, long)):
            raise TypeError("int", repr(results['granularity']))
        if not isinstance(results['bitmap'], (str, unicode)):
            raise TypeError("string", repr(results['bitmap']))
        return results

    def compose(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if not isinstance(args, dict):
            raise UnmarshalException('arguments', 'dict', repr(args))
        if "dbg" not in args:
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if not isinstance(dbg, (str, unicode)):
            raise TypeError("string", repr(dbg))
        if "sr" not in args:
            raise UnmarshalException('argument missing', 'sr', '')
        sr = args["sr"]
        if not isinstance(sr, (str, unicode)):
            raise TypeError("string", repr(sr))
        if "key" not in args:
            raise UnmarshalException('argument missing', 'key', '')
        key = args["key"]
        if not isinstance(key, (str, unicode)):
            raise TypeError("string", repr(key))
        if "key2" not in args:
            raise UnmarshalException('argument missing', 'key2', '')
        key2 = args["key2"]
        if not isinstance(key2, (str, unicode)):
            raise TypeError("string", repr(key2))
        results = self._impl.compose(dbg, sr, key, key2)
        return results

    def _dispatch(self, method, params):
        """type check inputs, call implementation, type check outputs and return"""
        args = params[0]
        return success(self._dispatcher_dict[method](args))


class Volume_skeleton(object):
    """
    Operations which operate on volumes (also known as
    Virtual Disk Images)
    """

    def __init__(self):
        pass

    def create(self, dbg, sr, name, description, size, sharable):
        """
        [create sr name description size] creates a new volume in [sr] with
        [name] and [description]. The volume will have size >= [size] i.e. it
        is always permissable for an implementation to round-up the volume to
        the nearest convenient block size
        """
        raise Unimplemented("Volume.create")

    def snapshot(self, dbg, sr, key):
        """
        [snapshot sr volume] creates a new volue which is a  snapshot of
        [volume] in [sr]. Snapshots should never be written to; they are
        intended for backup/restore only. Note the name and description are
        copied but any extra metadata associated by [set] is not copied.
        This can raise Activated_on_another_host(host_installation_uuid)
        if the VDI is already active on another host and snapshots
        can only be taken on the host that has the VDI active (if any).
        XAPI will take care of redirecting the request to the proper host
        """
        raise Unimplemented("Volume.snapshot")

    def clone(self, dbg, sr, key):
        """
        [clone sr volume] creates a new volume which is a writable clone of
        [volume] in [sr]. Note the name and description are copied but any
        extra metadata associated by [set] is not copied.
        """
        raise Unimplemented("Volume.clone")

    def copy(self, dbg, sr, key, dest_sr):
        """
        [copy sr volume dest_sr] creates a new volume as a writeable copy of
        [volume] in [dest_sr]. [dest_sr] may be the same as [sr] and the operation
        may be rejected if the volume management plugin cannot copy a volume
        between different SRs. It is expected that this operation is accelerated
        by the implementation and is more efficient than a blockwise replication
        through the local host. This operation should only be called if the plugin
        declares the VDI_COPY feature in the query response. If the operation is
        rejected then the caller will be expected to fall back to performing a
        blockwise copy.
        """
        raise Unimplemented("Volume.copy")

    def destroy(self, dbg, sr, key):
        """
        [destroy sr volume] removes [volume] from [sr]
        """
        raise Unimplemented("Volume.destroy")

    def set_name(self, dbg, sr, key, new_name):
        """
        [set_name sr volume new_name] changes the name of [volume]
        """
        raise Unimplemented("Volume.set_name")

    def set_description(self, dbg, sr, key, new_description):
        """
        [set_description sr volume new_description] changes the description
        of [volume]
        """
        raise Unimplemented("Volume.set_description")

    def set(self, dbg, sr, key, k, v):
        """
        [set sr volume key value] associates [key] with [value] in the
        metadata of [volume] Note these keys and values are not interpreted
        by the plugin; they are intended for the higher-level software only.
        """
        raise Unimplemented("Volume.set")

    def unset(self, dbg, sr, key, k):
        """
        [unset sr volume key] removes [key] and any value associated with it
        from the metadata of [volume] Note these keys and values are not
        interpreted by the plugin; they are intended for the higher-level
        software only.
        """
        raise Unimplemented("Volume.unset")

    def resize(self, dbg, sr, key, new_size):
        """
        [resize sr volume new_size] enlarges [volume] to be at least
        [new_size].
        """
        raise Unimplemented("Volume.resize")

    def stat(self, dbg, sr, key):
        """
        [stat sr volume] returns metadata associated with [volume].
        """
        raise Unimplemented("Volume.stat")

    def compare(self, dbg, sr, key, key2):
        """
        [compare sr volume1 volume2] compares the two volumes and returns a
        result of type blocklist that describes the differences between the
        two volumes. If the two volumes are unrelated, or the second volume
        does not exist, the result will be a list of the blocks that are
        non-empty in volume1. If this information is not available to the
        plugin, it should return a result indicating that all blocks are in
        use.
        """
        raise Unimplemented("Volume.compare")

    def similar_content(self, dbg, sr, key):
        """
        [similar_content sr volume] returns a list of VDIs which have similar
        content to [vdi]
        """
        raise Unimplemented("Volume.similar_content")

    def enable_cbt(self, dbg, sr, key):
        """
        [enable_cbt sr volume] enables Changed Block Tracking for [volume]
        """
        raise Unimplemented("Volume.enable_cbt")

    def disable_cbt(self, dbg, sr, key):
        """
        [disable_cbt sr volume] disables Changed Block Tracking for [volume]
        """
        raise Unimplemented("Volume.disable_cbt")

    def data_destroy(self, dbg, sr, key):
        """
        [data_destroy sr volume] deletes the data of the snapshot [volume]
        without deleting its changed block tracking metadata
        """
        raise Unimplemented("Volume.data_destroy")

    def list_changed_blocks(self, dbg, sr, key, key2, offset, length):
        """
        [list_changed_blocks sr volume1 volume2 offset length] returns the
        blocks that have changed between [volume1] and [volume2] in the extent
        specified by the given [offset] and [length] as a base64-encoded
        bitmap string. If this extent is not aligned to the granularity of the
        returned bitmap, then the bitmap will cover the area extended to the
        nearest block boundaries.
        """
        raise Unimplemented("Volume.list_changed_blocks")

    def compose(self, dbg, sr, key, key2):
        """
        [compose sr child_volume parent_volume] layers the updates from
        [child_volume] onto [parent_volume], modifying [child_volume].
        In the case of a delta file format this means updating the
        [child_volume] to have a parent or backing object defined by
        [parent_volume]. Implementations shall declare the VDI_COMPOSE
        feature for this method to be supported. After a successful
        return it should be assumed that the [parent_volume] is no
        longer valid. Calling SR.ls, will return the list of currently
        known, valid, volumes.
        """
        raise Unimplemented("Volume.compose")


class Volume_test(object):
    """
    Operations which operate on volumes (also known as
    Virtual Disk Images)
    """

    def __init__(self):
        pass

    def create(self, dbg, sr, name, description, size, sharable):
        """
        [create sr name description size] creates a new volume in [sr] with
        [name] and [description]. The volume will have size >= [size] i.e. it
        is always permissable for an implementation to round-up the volume to
        the nearest convenient block size
        """
        return {"key": "string", "uuid": None, "name": "string", "description": "string", "read_write": True, "sharable": True, "virtual_size": long(0), "physical_utilisation": long(0), "uri": ["string"], "keys": {"string": "string"}, "volume_type": None, "cbt_enabled": None}

    def snapshot(self, dbg, sr, key):
        """
        [snapshot sr volume] creates a new volue which is a  snapshot of
        [volume] in [sr]. Snapshots should never be written to; they are
        intended for backup/restore only. Note the name and description are
        copied but any extra metadata associated by [set] is not copied.
        This can raise Activated_on_another_host(host_installation_uuid)
        if the VDI is already active on another host and snapshots
        can only be taken on the host that has the VDI active (if any).
        XAPI will take care of redirecting the request to the proper host
        """
        return {"key": "string", "uuid": None, "name": "string", "description": "string", "read_write": True, "sharable": True, "virtual_size": long(0), "physical_utilisation": long(0), "uri": ["string"], "keys": {"string": "string"}, "volume_type": None, "cbt_enabled": None}

    def clone(self, dbg, sr, key):
        """
        [clone sr volume] creates a new volume which is a writable clone of
        [volume] in [sr]. Note the name and description are copied but any
        extra metadata associated by [set] is not copied.
        """
        return {"key": "string", "uuid": None, "name": "string", "description": "string", "read_write": True, "sharable": True, "virtual_size": long(0), "physical_utilisation": long(0), "uri": ["string"], "keys": {"string": "string"}, "volume_type": None, "cbt_enabled": None}

    def copy(self, dbg, sr, key, dest_sr):
        """
        [copy sr volume dest_sr] creates a new volume as a writeable copy of
        [volume] in [dest_sr]. [dest_sr] may be the same as [sr] and the operation
        may be rejected if the volume management plugin cannot copy a volume
        between different SRs. It is expected that this operation is accelerated
        by the implementation and is more efficient than a blockwise replication
        through the local host. This operation should only be called if the plugin
        declares the VDI_COPY feature in the query response. If the operation is
        rejected then the caller will be expected to fall back to performing a
        blockwise copy.
        """
        return {"key": "string", "uuid": None, "name": "string", "description": "string", "read_write": True, "sharable": True, "virtual_size": long(0), "physical_utilisation": long(0), "uri": ["string"], "keys": {"string": "string"}, "volume_type": None, "cbt_enabled": None}

    def destroy(self, dbg, sr, key):
        """
        [destroy sr volume] removes [volume] from [sr]
        """

    def set_name(self, dbg, sr, key, new_name):
        """
        [set_name sr volume new_name] changes the name of [volume]
        """

    def set_description(self, dbg, sr, key, new_description):
        """
        [set_description sr volume new_description] changes the description
        of [volume]
        """

    def set(self, dbg, sr, key, k, v):
        """
        [set sr volume key value] associates [key] with [value] in the
        metadata of [volume] Note these keys and values are not interpreted
        by the plugin; they are intended for the higher-level software only.
        """

    def unset(self, dbg, sr, key, k):
        """
        [unset sr volume key] removes [key] and any value associated with it
        from the metadata of [volume] Note these keys and values are not
        interpreted by the plugin; they are intended for the higher-level
        software only.
        """

    def resize(self, dbg, sr, key, new_size):
        """
        [resize sr volume new_size] enlarges [volume] to be at least
        [new_size].
        """

    def stat(self, dbg, sr, key):
        """
        [stat sr volume] returns metadata associated with [volume].
        """
        return {"key": "string", "uuid": None, "name": "string", "description": "string", "read_write": True, "sharable": True, "virtual_size": long(0), "physical_utilisation": long(0), "uri": ["string"], "keys": {"string": "string"}, "volume_type": None, "cbt_enabled": None}

    def compare(self, dbg, sr, key, key2):
        """
        [compare sr volume1 volume2] compares the two volumes and returns a
        result of type blocklist that describes the differences between the
        two volumes. If the two volumes are unrelated, or the second volume
        does not exist, the result will be a list of the blocks that are
        non-empty in volume1. If this information is not available to the
        plugin, it should return a result indicating that all blocks are in
        use.
        """
        return {"blocksize": long(0), "ranges": [[]]}

    def similar_content(self, dbg, sr, key):
        """
        [similar_content sr volume] returns a list of VDIs which have similar
        content to [vdi]
        """
        return ["string"]

    def enable_cbt(self, dbg, sr, key):
        """
        [enable_cbt sr volume] enables Changed Block Tracking for [volume]
        """

    def disable_cbt(self, dbg, sr, key):
        """
        [disable_cbt sr volume] disables Changed Block Tracking for [volume]
        """

    def data_destroy(self, dbg, sr, key):
        """
        [data_destroy sr volume] deletes the data of the snapshot [volume]
        without deleting its changed block tracking metadata
        """

    def list_changed_blocks(self, dbg, sr, key, key2, offset, length):
        """
        [list_changed_blocks sr volume1 volume2 offset length] returns the
        blocks that have changed between [volume1] and [volume2] in the extent
        specified by the given [offset] and [length] as a base64-encoded
        bitmap string. If this extent is not aligned to the granularity of the
        returned bitmap, then the bitmap will cover the area extended to the
        nearest block boundaries.
        """
        return {"granularity": long(0), "bitmap": "string"}

    def compose(self, dbg, sr, key, key2):
        """
        [compose sr child_volume parent_volume] layers the updates from
        [child_volume] onto [parent_volume], modifying [child_volume].
        In the case of a delta file format this means updating the
        [child_volume] to have a parent or backing object defined by
        [parent_volume]. Implementations shall declare the VDI_COMPOSE
        feature for this method to be supported. After a successful
        return it should be assumed that the [parent_volume] is no
        longer valid. Calling SR.ls, will return the list of currently
        known, valid, volumes.
        """


class Volume_commandline(object):
    """Parse command-line arguments and call an implementation."""

    def __init__(self, impl):
        self.impl = impl
        self.dispatcher = Volume_server_dispatcher(self.impl)

    def _parse_create(self):
        """
        [create sr name description size] creates a new volume in [sr] with
        [name] and [description]. The volume will have size >= [size] i.e. it
        is always permissable for an implementation to round-up the volume to
        the nearest convenient block size
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[create sr name description size] creates a new volume in [sr] with  [name] and [description]. The volume will have size >= [size] i.e. it  is always permissable for an implementation to round-up the volume to  the nearest convenient block size')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('name', action='store', help='A human-readable name to associate with the new disk. This name is  intended to be short, to be a good summary of the disk.')
        parser.add_argument('description', action='store', help='A human-readable description to associate with the new disk. This can  be arbitrarily long, up to the general string size limit.')
        parser.add_argument('size', action='store', help='A minimum size (in bytes) for the disk. Depending on the  characteristics of the implementation this may be rounded up to  (for example) the nearest convenient block size. The created disk  will not be smaller than this size.', type=long)
        parser.add_argument('sharable', action='store', help='Indicates whether the VDI can be attached by multiple hosts at once. This is used for example by the HA statefile and XAPI redo log.', type=lambda x: json.loads(x.lower()))
        return vars(parser.parse_args())

    def _parse_snapshot(self):
        """
        [snapshot sr volume] creates a new volue which is a  snapshot of
        [volume] in [sr]. Snapshots should never be written to; they are
        intended for backup/restore only. Note the name and description are
        copied but any extra metadata associated by [set] is not copied.
        This can raise Activated_on_another_host(host_installation_uuid)
        if the VDI is already active on another host and snapshots
        can only be taken on the host that has the VDI active (if any).
        XAPI will take care of redirecting the request to the proper host
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[snapshot sr volume] creates a new volue which is a  snapshot of  [volume] in [sr]. Snapshots should never be written to; they are  intended for backup/restore only. Note the name and description are  copied but any extra metadata associated by [set] is not copied. This can raise Activated_on_another_host(host_installation_uuid) if the VDI is already active on another host and snapshots can only be taken on the host that has the VDI active (if any). XAPI will take care of redirecting the request to the proper host')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        return vars(parser.parse_args())

    def _parse_clone(self):
        """
        [clone sr volume] creates a new volume which is a writable clone of
        [volume] in [sr]. Note the name and description are copied but any
        extra metadata associated by [set] is not copied.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[clone sr volume] creates a new volume which is a writable clone of  [volume] in [sr]. Note the name and description are copied but any  extra metadata associated by [set] is not copied.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        return vars(parser.parse_args())

    def _parse_copy(self):
        """
        [copy sr volume dest_sr] creates a new volume as a writeable copy of
        [volume] in [dest_sr]. [dest_sr] may be the same as [sr] and the operation
        may be rejected if the volume management plugin cannot copy a volume
        between different SRs. It is expected that this operation is accelerated
        by the implementation and is more efficient than a blockwise replication
        through the local host. This operation should only be called if the plugin
        declares the VDI_COPY feature in the query response. If the operation is
        rejected then the caller will be expected to fall back to performing a
        blockwise copy.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[copy sr volume dest_sr] creates a new volume as a writeable copy of  [volume] in [dest_sr]. [dest_sr] may be the same as [sr] and the operation  may be rejected if the volume management plugin cannot copy a volume  between different SRs. It is expected that this operation is accelerated  by the implementation and is more efficient than a blockwise replication  through the local host. This operation should only be called if the plugin  declares the VDI_COPY feature in the query response. If the operation is  rejected then the caller will be expected to fall back to performing a  blockwise copy.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        parser.add_argument('dest_sr', action='store', help='The Destination Storage Repository')
        return vars(parser.parse_args())

    def _parse_destroy(self):
        """
        [destroy sr volume] removes [volume] from [sr]
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[destroy sr volume] removes [volume] from [sr]')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        return vars(parser.parse_args())

    def _parse_set_name(self):
        """
        [set_name sr volume new_name] changes the name of [volume]
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[set_name sr volume new_name] changes the name of [volume]')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        parser.add_argument('new_name', action='store', help='New name')
        return vars(parser.parse_args())

    def _parse_set_description(self):
        """
        [set_description sr volume new_description] changes the description
        of [volume]
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[set_description sr volume new_description] changes the description  of [volume]')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        parser.add_argument('new_description', action='store', help='New description')
        return vars(parser.parse_args())

    def _parse_set(self):
        """
        [set sr volume key value] associates [key] with [value] in the
        metadata of [volume] Note these keys and values are not interpreted
        by the plugin; they are intended for the higher-level software only.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[set sr volume key value] associates [key] with [value] in the  metadata of [volume] Note these keys and values are not interpreted  by the plugin; they are intended for the higher-level software only.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        parser.add_argument('k', action='store', help='Key')
        parser.add_argument('v', action='store', help='Value')
        return vars(parser.parse_args())

    def _parse_unset(self):
        """
        [unset sr volume key] removes [key] and any value associated with it
        from the metadata of [volume] Note these keys and values are not
        interpreted by the plugin; they are intended for the higher-level
        software only.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[unset sr volume key] removes [key] and any value associated with it  from the metadata of [volume] Note these keys and values are not  interpreted by the plugin; they are intended for the higher-level  software only.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        parser.add_argument('k', action='store', help='Key')
        return vars(parser.parse_args())

    def _parse_resize(self):
        """
        [resize sr volume new_size] enlarges [volume] to be at least
        [new_size].
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[resize sr volume new_size] enlarges [volume] to be at least  [new_size].')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        parser.add_argument('new_size', action='store', help='New disk size', type=long)
        return vars(parser.parse_args())

    def _parse_stat(self):
        """
        [stat sr volume] returns metadata associated with [volume].
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[stat sr volume] returns metadata associated with [volume].')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        return vars(parser.parse_args())

    def _parse_compare(self):
        """
        [compare sr volume1 volume2] compares the two volumes and returns a
        result of type blocklist that describes the differences between the
        two volumes. If the two volumes are unrelated, or the second volume
        does not exist, the result will be a list of the blocks that are
        non-empty in volume1. If this information is not available to the
        plugin, it should return a result indicating that all blocks are in
        use.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[compare sr volume1 volume2] compares the two volumes and returns a  result of type blocklist that describes the differences between the  two volumes. If the two volumes are unrelated, or the second volume  does not exist, the result will be a list of the blocks that are  non-empty in volume1. If this information is not available to the  plugin, it should return a result indicating that all blocks are in  use.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        parser.add_argument('key2', action='store', help='The volume key')
        return vars(parser.parse_args())

    def _parse_similar_content(self):
        """
        [similar_content sr volume] returns a list of VDIs which have similar
        content to [vdi]
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[similar_content sr volume] returns a list of VDIs which have similar content to [vdi]')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        return vars(parser.parse_args())

    def _parse_enable_cbt(self):
        """
        [enable_cbt sr volume] enables Changed Block Tracking for [volume]
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[enable_cbt sr volume] enables Changed Block Tracking for [volume]')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        return vars(parser.parse_args())

    def _parse_disable_cbt(self):
        """
        [disable_cbt sr volume] disables Changed Block Tracking for [volume]
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[disable_cbt sr volume] disables Changed Block Tracking for [volume]')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        return vars(parser.parse_args())

    def _parse_data_destroy(self):
        """
        [data_destroy sr volume] deletes the data of the snapshot [volume]
        without deleting its changed block tracking metadata
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[data_destroy sr volume] deletes the data of the snapshot [volume] without deleting its changed block tracking metadata')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        return vars(parser.parse_args())

    def _parse_list_changed_blocks(self):
        """
        [list_changed_blocks sr volume1 volume2 offset length] returns the
        blocks that have changed between [volume1] and [volume2] in the extent
        specified by the given [offset] and [length] as a base64-encoded
        bitmap string. If this extent is not aligned to the granularity of the
        returned bitmap, then the bitmap will cover the area extended to the
        nearest block boundaries.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[list_changed_blocks sr volume1 volume2 offset length] returns the blocks that have changed between [volume1] and [volume2] in the extent specified by the given [offset] and [length] as a base64-encoded bitmap string. If this extent is not aligned to the granularity of the returned bitmap, then the bitmap will cover the area extended to the nearest block boundaries.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        parser.add_argument('key2', action='store', help='The volume key')
        parser.add_argument('offset', action='store', help='The offset of the extent for which changed blocks should be computed', type=long)
        parser.add_argument('length', action='store', help='The length of the extent for which changed blocks should be computed', type=long)
        return vars(parser.parse_args())

    def _parse_compose(self):
        """
        [compose sr child_volume parent_volume] layers the updates from
        [child_volume] onto [parent_volume], modifying [child_volume].
        In the case of a delta file format this means updating the
        [child_volume] to have a parent or backing object defined by
        [parent_volume]. Implementations shall declare the VDI_COMPOSE
        feature for this method to be supported. After a successful
        return it should be assumed that the [parent_volume] is no
        longer valid. Calling SR.ls, will return the list of currently
        known, valid, volumes.
        """
        # in --json mode we don't have any other arguments
        if ('--json' in sys.argv or '-j' in sys.argv):
            jsondict = json.loads(sys.stdin.readline(),)
            jsondict['json'] = True
            return jsondict
        parser = argparse.ArgumentParser(description='[compose sr child_volume parent_volume] layers the updates from  [child_volume] onto [parent_volume], modifying [child_volume].  In the case of a delta file format this means updating the  [child_volume] to have a parent or backing object defined by  [parent_volume]. Implementations shall declare the VDI_COMPOSE  feature for this method to be supported. After a successful  return it should be assumed that the [parent_volume] is no  longer valid. Calling SR.ls, will return the list of currently  known, valid, volumes.')
        parser.add_argument('-j', '--json', action='store_const', const=True, default=False, help='Read json from stdin, print json to stdout', required=False)
        parser.add_argument('dbg', action='store', help='Debug context from the caller')
        parser.add_argument('sr', action='store', help='The Storage Repository')
        parser.add_argument('key', action='store', help='The volume key')
        parser.add_argument('key2', action='store', help='The volume key')
        return vars(parser.parse_args())

    def create(self):
        """
        [create sr name description size] creates a new volume in [sr] with
        [name] and [description]. The volume will have size >= [size] i.e. it
        is always permissable for an implementation to round-up the volume to
        the nearest convenient block size
        """
        use_json = False
        try:
            request = self._parse_create()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.create(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def snapshot(self):
        """
        [snapshot sr volume] creates a new volue which is a  snapshot of
        [volume] in [sr]. Snapshots should never be written to; they are
        intended for backup/restore only. Note the name and description are
        copied but any extra metadata associated by [set] is not copied.
        This can raise Activated_on_another_host(host_installation_uuid)
        if the VDI is already active on another host and snapshots
        can only be taken on the host that has the VDI active (if any).
        XAPI will take care of redirecting the request to the proper host
        """
        use_json = False
        try:
            request = self._parse_snapshot()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.snapshot(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def clone(self):
        """
        [clone sr volume] creates a new volume which is a writable clone of
        [volume] in [sr]. Note the name and description are copied but any
        extra metadata associated by [set] is not copied.
        """
        use_json = False
        try:
            request = self._parse_clone()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.clone(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def copy(self):
        """
        [copy sr volume dest_sr] creates a new volume as a writeable copy of
        [volume] in [dest_sr]. [dest_sr] may be the same as [sr] and the operation
        may be rejected if the volume management plugin cannot copy a volume
        between different SRs. It is expected that this operation is accelerated
        by the implementation and is more efficient than a blockwise replication
        through the local host. This operation should only be called if the plugin
        declares the VDI_COPY feature in the query response. If the operation is
        rejected then the caller will be expected to fall back to performing a
        blockwise copy.
        """
        use_json = False
        try:
            request = self._parse_copy()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.copy(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def destroy(self):
        """
        [destroy sr volume] removes [volume] from [sr]
        """
        use_json = False
        try:
            request = self._parse_destroy()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.destroy(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def set_name(self):
        """
        [set_name sr volume new_name] changes the name of [volume]
        """
        use_json = False
        try:
            request = self._parse_set_name()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.set_name(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def set_description(self):
        """
        [set_description sr volume new_description] changes the description
        of [volume]
        """
        use_json = False
        try:
            request = self._parse_set_description()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.set_description(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def set(self):
        """
        [set sr volume key value] associates [key] with [value] in the
        metadata of [volume] Note these keys and values are not interpreted
        by the plugin; they are intended for the higher-level software only.
        """
        use_json = False
        try:
            request = self._parse_set()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.set(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def unset(self):
        """
        [unset sr volume key] removes [key] and any value associated with it
        from the metadata of [volume] Note these keys and values are not
        interpreted by the plugin; they are intended for the higher-level
        software only.
        """
        use_json = False
        try:
            request = self._parse_unset()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.unset(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def resize(self):
        """
        [resize sr volume new_size] enlarges [volume] to be at least
        [new_size].
        """
        use_json = False
        try:
            request = self._parse_resize()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.resize(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def stat(self):
        """
        [stat sr volume] returns metadata associated with [volume].
        """
        use_json = False
        try:
            request = self._parse_stat()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.stat(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def compare(self):
        """
        [compare sr volume1 volume2] compares the two volumes and returns a
        result of type blocklist that describes the differences between the
        two volumes. If the two volumes are unrelated, or the second volume
        does not exist, the result will be a list of the blocks that are
        non-empty in volume1. If this information is not available to the
        plugin, it should return a result indicating that all blocks are in
        use.
        """
        use_json = False
        try:
            request = self._parse_compare()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.compare(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def similar_content(self):
        """
        [similar_content sr volume] returns a list of VDIs which have similar
        content to [vdi]
        """
        use_json = False
        try:
            request = self._parse_similar_content()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.similar_content(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def enable_cbt(self):
        """
        [enable_cbt sr volume] enables Changed Block Tracking for [volume]
        """
        use_json = False
        try:
            request = self._parse_enable_cbt()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.enable_cbt(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def disable_cbt(self):
        """
        [disable_cbt sr volume] disables Changed Block Tracking for [volume]
        """
        use_json = False
        try:
            request = self._parse_disable_cbt()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.disable_cbt(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def data_destroy(self):
        """
        [data_destroy sr volume] deletes the data of the snapshot [volume]
        without deleting its changed block tracking metadata
        """
        use_json = False
        try:
            request = self._parse_data_destroy()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.data_destroy(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def list_changed_blocks(self):
        """
        [list_changed_blocks sr volume1 volume2 offset length] returns the
        blocks that have changed between [volume1] and [volume2] in the extent
        specified by the given [offset] and [length] as a base64-encoded
        bitmap string. If this extent is not aligned to the granularity of the
        returned bitmap, then the bitmap will cover the area extended to the
        nearest block boundaries.
        """
        use_json = False
        try:
            request = self._parse_list_changed_blocks()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.list_changed_blocks(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn

    def compose(self):
        """
        [compose sr child_volume parent_volume] layers the updates from
        [child_volume] onto [parent_volume], modifying [child_volume].
        In the case of a delta file format this means updating the
        [child_volume] to have a parent or backing object defined by
        [parent_volume]. Implementations shall declare the VDI_COMPOSE
        feature for this method to be supported. After a successful
        return it should be assumed that the [parent_volume] is no
        longer valid. Calling SR.ls, will return the list of currently
        known, valid, volumes.
        """
        use_json = False
        try:
            request = self._parse_compose()
            use_json = 'json' in request and request['json']
            results = self.dispatcher.compose(request)
            print(json.dumps(results))
        except Exception as exn:
            if use_json:
                handle_exception(exn)
            else:
                traceback.print_exc()
                raise exn


class volume_server_dispatcher(object):
    """Demux calls to individual interface server_dispatchers"""

    def __init__(self, SR=None, Volume=None):
        self.SR = SR
        self.Volume = Volume
        self._dispatcher_dict = {
            "SR": self.SR._dispatch,
            "Volume": self.Volume._dispatch
        }

    def _dispatch(self, method, params):
        try:
            logging.log("method = %s params = %s", method, repr(params))
            class_ = method.split('.')[0]
            if class_ in self._dispatcher_dict:
                return self._dispatcher_dict[class_](method, params)
            raise UnknownMethod(method)
        except Rpc_light_failure as rpc_exn:
            logging.log("caught %s", rpc_exn)
            traceback.print_exc()
            logging.log("returning %s", repr(rpc_exn.failure()))
            return rpc_exn.failure()
        except Exception as exn:
            logging.log("caught %s", exn)
            traceback.print_exc()
            return InternalError(get_str(exn)).failure()


class volume_server_test(volume_server_dispatcher):
    """Create a server which will respond to all calls, returning arbitrary values. This is intended as a marshal/unmarshal test."""

    def __init__(self):
        volume_server_dispatcher.__init__(self, SR_server_dispatcher(SR_test()), Volume_server_dispatcher(Volume_test()))
